> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List periods for a commitment

GET https://rest.test.zuora.com/commitments/periods

Lists periods of the commitment. You can paginate the results using `page` and `pageSize` query parameters.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/orders-and-subscriptions/commitments/get-commitment-periods

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `commitmentKey` (string, optional) — The unique identifier or number of the commitment. Required if `startDate`, `endDate`, and `accountNumber` are not all provided. Either specify `commitmentKey`, or provide `startDate`, `endDate`, and `accountNumber` together.
- `startDate` (date, optional) — Start date of the billing period in `YYYY-MM-DD` format. Date filters must be up to 5 years apart. Required if `commitmentKey` is not provided. Must be used together with `endDate` and `accountNumber`.
- `endDate` (date, optional) — End date of the billing period in `YYYY-MM-DD` format. Date filters must be up to 5 years apart. Required if `commitmentKey` is not provided. Must be used together with `startDate` and `accountNumber`.
- `accountNumber` (string, optional) — Account number to which the commitment belongs to. Required if `commitmentKey` is not provided. Must be used together with `startDate` and `endDate`.
- `page` (integer, optional, default: 1) — Page number for pagination.
- `pageSize` (integer, optional, default: 20) — Page size for pagination.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `total` (integer, optional) — Total number of periods available for the given commitment/Total commitments for given account.
- `page` (integer, optional) — The current page number.
- `pageSize` (integer, optional) — The number of results returned per page.
- `periods` (list of CommitmentPeriod, optional) — A list of commitment period objects.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### CommitmentPeriod

- `id` (string, optional) — ID of the commitment period.
- `commitmentId` (string, optional) — ID of the commitment.
- `commitmentNumber` (string, optional) — The number of the commitment.
- `version` (integer, optional) — Version of the commitment period.
- `type` (enum, optional) — The type of the commitment.
  - Allowed values: `MinCommitment`, `MaxCommitment`
- `priority` (integer, optional) — Priority of the commitment.
- `currency` (string, optional) — Currency of the commitment.
- `isProrated` (boolean, optional) — Indicates if the period is prorated.
- `amount` (double, optional) — The total amount of the commitment within the current period.
- `balance` (double, optional) — The balance amount to be spent within the current period.
- `trueUpAmount` (double, optional, nullable) — Total true-up amount for this commitment period. It will be null if it is a prepaid commitment or if it is not evaluated yet. This will be a non-negative number.
- `expiredAmount` (double, optional, nullable) — Total expired amount for this commitment period. It will be null if it is a postpaid commitment or if the period is not evaluated yet. This will be a non-negative number.
- `billedTotalSpending` (double, optional) — Sum of charge contribution amount.
- `status` (enum, optional) — Status of the commitment period.
  - Allowed values: `Active`, `Cancelled`, `Evaluated`, `ActiveWithDrawdown`, `CancelledPendingEvaluation`
- `startDate` (date, optional) — The start date of the commitment period.
- `endDate` (date, optional) — The end date of the commitment period.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "total": 1,
  "page": 1,
  "pageSize": 1,
  "periods": [
    {
      "id": "0df89cf12e650006ac13624398764f1b",
      "commitmentId": "8ad08ca797ef6ca50197f3cce6267991",
      "commitmentNumber": "TW-0001",
      "version": 1,
      "type": "MinCommitment",
      "priority": 1,
      "currency": "USD",
      "isProrated": false,
      "amount": 100,
      "balance": 500,
      "trueUpAmount": 0,
      "expiredAmount": null,
      "billedTotalSpending": 500,
      "status": "ActiveWithDrawdown",
      "startDate": "2024-01-01",
      "endDate": "2024-12-31"
    }
  ]
}
```

**SDK Code**

```python Commitments_getCommitmentPeriods_example
import requests

url = "https://rest.test.zuora.com/commitments/periods"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Commitments_getCommitmentPeriods_example
const url = 'https://rest.test.zuora.com/commitments/periods';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Commitments_getCommitmentPeriods_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/commitments/periods"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Commitments_getCommitmentPeriods_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/commitments/periods")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Commitments_getCommitmentPeriods_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/commitments/periods")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Commitments_getCommitmentPeriods_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/commitments/periods', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Commitments_getCommitmentPeriods_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/commitments/periods");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Commitments_getCommitmentPeriods_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/commitments/periods")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```